Index: src/map/skill.c
===================================================================
--- src/map/skill.c (revision 23)
+++ src/map/skill.c (revision 24)
@@ -5595,5 +5588,5 @@
 			static const int per[5][2]={{20,50},{50,60},{25,75},{60,64},{34,67}};
 			int rnd = rand()%100;
-			i = (skilllv-1)%5;
+			i = (skilllv-1)%5; 
 			if(rnd<per[i][0]) //Self
 				bl = src;
@@ -5662,5 +5655,5 @@
 		mobskill_event(dstmd, src, tick, MSC_SKILLUSED|(skillid<<16));
 	}
-
+	
 	if (sd && !(flag&1) && sd->state.arrow_atk) //Consume arrow on last invocation to this skill.
 		battle_consume_ammo(sd, skillid, skilllv);
@@ -5694,5 +5687,6 @@
 	}
 
-	if(ud->skillid != SA_CASTCANCEL ) {
+	if(ud->skillid != SA_CASTCANCEL )
+	{// otherwise handled in unit_skillcastcancel()
 		if( ud->skilltimer != tid ) {
 			ShowError("skill_castend_id: Timer mismatch %d!=%d!\n", ud->skilltimer, tid);
@@ -5700,7 +5694,12 @@
 			return 0;
 		}
-		if( sd && ud->skilltimer != -1 && pc_checkskill(sd,SA_FREECAST))
-			status_freecast_switch(sd);
-		ud->skilltimer=-1;
+
+		if( sd && ud->skilltimer != -1 && pc_checkskill(sd,SA_FREECAST) > 0 )
+		{// restore original walk speed
+			ud->skilltimer = -1;
+			status_calc_bl(&sd->bl, SCB_SPEED);
+		}
+
+		ud->skilltimer = -1;
 	}
 
@@ -5765,5 +5764,5 @@
 			if(inf2 & (INF2_PARTY_ONLY|INF2_GUILD_ONLY) && src != target)
 			{
-				inf |=
+				inf |= 	
 					(inf2&INF2_PARTY_ONLY?BCT_PARTY:0)|
 					(inf2&INF2_GUILD_ONLY?BCT_GUILD:0);
@@ -5807,5 +5806,5 @@
 		if(sd && !skill_check_condition(sd,ud->skillid, ud->skilllv,1))
 			break;
-
+			
 		if(hd && !skill_check_condition_hom(hd,ud->skillid, ud->skilllv,1))	//[orn]
 			break;
@@ -5816,10 +5815,10 @@
 		if (ud->walktimer != -1 && ud->skillid != TK_RUN)
 			unit_stop_walking(src,1);
-
+		
 		ud->canact_tick = tick + skill_delayfix(src, ud->skillid, ud->skilllv);
-
+	
 		if (skill_get_state(ud->skillid) != ST_MOVE_ENABLE)
 			unit_set_walkdelay(src, tick, battle_config.default_walk_delay+skill_get_walkdelay(ud->skillid, ud->skilllv), 1);
-
+		
 		if(battle_config.skill_log && battle_config.skill_log&src->type)
 			ShowInfo("Type %d, ID %d skill castend id [id =%d, lv=%d, target ID %d]\n",
@@ -5876,5 +5875,5 @@
 			if (dy > 0) dy++;
 			else if(dy < 0) dy--;
-
+			
 			if (unit_movepos(src, src->x+dx, src->y+dy, 1, 1))
 			{	//Display movement + animation.
@@ -5897,5 +5896,5 @@
 
 /*==========================================
- *
+ * 
  *------------------------------------------*/
 int skill_castend_pos(int tid, unsigned int tick, int id, intptr data)
@@ -5918,5 +5917,5 @@
 		return 0;
 	}
-
+	
 	if( ud->skilltimer != tid )
 	{
@@ -5926,8 +5925,11 @@
 	}
 
-	if(sd && ud->skilltimer != -1 && pc_checkskill(sd,SA_FREECAST))
-		status_freecast_switch(sd);
-
+	if( sd && ud->skilltimer != -1 && pc_checkskill(sd,SA_FREECAST) > 0 )
+	{// restore original walk speed
+		ud->skilltimer=-1;
+		status_calc_bl(&sd->bl, SCB_SPEED);
+	}
 	ud->skilltimer=-1;
+
 	do {
 		if(status_isdead(src))
@@ -5937,5 +5939,5 @@
 			skill_get_unit_flag(ud->skillid)&UF_NOREITERATION &&
 			skill_check_unit_range(src,ud->skillx,ud->skilly,ud->skillid,ud->skilllv)
-		  )
+		  ) 
 		{
 			if (sd) clif_skill_fail(sd,ud->skillid,0,0);
@@ -5976,5 +5978,5 @@
 			}
 		}
-
+			
 		if(sd && !skill_check_condition(sd,ud->skillid, ud->skilllv, 1))
 			break;
@@ -6062,5 +6064,5 @@
 		skill_area_temp[1] = src->id;
 		i = skill_get_splash(skillid, skilllv);
-		map_foreachinarea(skill_area_sub,
+		map_foreachinarea(skill_area_sub, 
 			src->m, x-i, y-i, x+i, y+i, BL_PC,
 			src, skillid, skilllv, tick, flag|BCT_ALL|1,
@@ -6089,15 +6091,13 @@
 			src->m, x-i, y-i, x+i,y+i,BL_SKILL);
 		break;
-
+//the code changed alot and jumped around.
 	case WL_HELLFIRE: // Warlock Hellfire [Brain]
-	//clif_specialeffect(sd, 92, AREA); //Meteor Effect on caster, cant set on ground
-	clif_skill_poseffect(src,WZ_METEOR,skilllv,x,y,tick); //Meteor Effect
-	clif_skill_nodamage(src, src, skillid, 0, 1); //Lalala, just to show the skill yell correctly
-	clif_specialeffect(src, 55, AREA); //Red Cast Effect on caster
-	// Continue reading because skill_unitsetting is bellow
-
-
+		//clif_specialeffect(sd, 92, AREA); //Meteor Effect on caster, cant set on ground
+		clif_skill_poseffect(src,WZ_METEOR,skilllv,x,y,tick); //Meteor Effect
+		clif_skill_nodamage(src, src, skillid, 0, 1); //Lalala, just to show the skill yell correctly
+		clif_specialeffect(src, 55, AREA); //Red Cast Effect on caster
+		// Continue reading because skill_unitsetting is bellow
 	case MG_SAFETYWALL:
-	case MG_FIREWALL:
+	case MG_FIREWALL:	
 	case MG_THUNDERSTORM:
 	case AL_PNEUMA:
@@ -6256,58 +6256,62 @@
 				md->deletetimer = add_timer (gettick() + skill_get_time(skillid,skilllv), mob_timer_delete, md->bl.id, 0);
 				mob_spawn (md); //Now it is ready for spawning.
-                // @showsummon command implementation [Brainstorm]
-		if(sd->state.showsummon){
-			char output[256];
-			sprintf(output,
-			"[Summon] HP : %d | STR : %d DEX : %d VIT : %d INT : %d AGI : %d LUK : %d",
-			md->status.max_hp,md->status.str,md->status.dex,md->status.vit,md->status.int_,md->status.agi,md->status.luk);
-			clif_disp_onlyself(sd,output,strlen(output));
-			sprintf(output,
-			"[%s] ATK : %d~%d | DEF: %d+%d MDEF: %d+%d | HIT: %d FLEE: %d",
-			md->name,md->status.rhw.atk,md->status.rhw.atk2,md->status.def,md->status.def2,md->status.mdef,md->status.mdef2,md->status.hit,md->status.flee);
-			clif_disp_onlyself(sd,output,strlen(output));
-		}
-
-			}
-		}
-		break;
-
+//Does this really belong here?
+				// @showsummon command implementation [Brainstorm]
+				if(sd->state.showsummon){
+					char output[256];
+					sprintf(output,
+						"[Summon] HP : %d | STR : %d DEX : %d VIT : %d INT : %d AGI : %d LUK : %d",
+						md->status.max_hp,md->status.str,md->status.dex,md->status.vit,md->status.int_,md->status.agi,md->status.luk);
+					clif_disp_onlyself(sd,output,strlen(output));
+					sprintf(output,
+						"[%s] ATK : %d~%d | DEF: %d+%d MDEF: %d+%d | HIT: %d FLEE: %d",
+						md->name,md->status.rhw.atk,md->status.rhw.atk2,md->status.def,md->status.def2,md->status.mdef,md->status.mdef2,md->status.hit,md->status.flee);
+					clif_disp_onlyself(sd,output,strlen(output));
+				}
+
+			}
+		}
+		break;
+		
+//HUGE lump of code!
+//Some of the code repeats itself, Unless it just recites it for other classes it may be a problem
 	case AD_FAMILIAR: // Adept Summon Familiar [Brain]
-	if( sd )
-	{
-		int id;
-		int mob_class;
-		struct mob_data* md;
-		mob_class = pc_readglobalreg(sd, "ADEPT_FAMILIAR");
-		if( mob_class == 0 )
+		if( sd )
 		{
-		mob_class = mob_get_random_id(4, 0x1, 0);
-		pc_setglobalreg(sd, "ADEPT_FAMILIAR", mob_class);
-		}
-		id = mob_once_spawn(sd,src->m,src->x,src->y,"--en--",mob_class,1,"");
-		md = (struct mob_data *)map_id2bl(id);
-		if( md != NULL )
-		{
-		md->master_id = sd->bl.id;
-		md->special_state.ai = 1;
-		md->status.mode = md->status.mode|MD_AGGRESSIVE;
-		status_calc_mob(md,0); //Recalc their stats based on passive bonus
-		md->status.hp = md->status.max_hp; //Must be here or the code wont update it
-		// @showsummon command implementation [Brainstorm]
-		if(sd->state.showsummon){
-			char output[256];
-			sprintf(output,
-			"[Summon] HP : %d | STR : %d DEX : %d VIT : %d INT : %d AGI : %d LUK : %d",
-			md->status.max_hp,md->status.str,md->status.dex,md->status.vit,md->status.int_,md->status.agi,md->status.luk);
-			clif_disp_onlyself(sd,output,strlen(output));
-			sprintf(output,
-			"[%s] ATK : %d~%d | DEF: %d+%d MDEF: %d+%d | HIT: %d FLEE: %d",
-			md->name,md->status.rhw.atk,md->status.rhw.atk2,md->status.def,md->status.def2,md->status.mdef,md->status.mdef2,md->status.hit,md->status.flee);
-			clif_disp_onlyself(sd,output,strlen(output));
-		}
-		md->deletetimer = add_timer(gettick() + skill_get_time(skillid,skilllv), mob_timer_delete, id, 0);
-		}
-	}
-	break;
+			int id;
+			int mob_class;
+			struct mob_data* md;
+
+			mob_class = pc_readglobalreg(sd, "ADEPT_FAMILIAR");
+			if( mob_class == 0 )
+			{
+				mob_class = mob_get_random_id(4, 0x1, 0);
+				pc_setglobalreg(sd, "ADEPT_FAMILIAR", mob_class);
+			}
+			id = mob_once_spawn(sd,src->m,src->x,src->y,"--en--",mob_class,1,"");
+			md = (struct mob_data *)map_id2bl(id);
+			if( md != NULL )
+			{
+				md->master_id = sd->bl.id;
+				md->special_state.ai = 1;
+				md->status.mode = md->status.mode|MD_AGGRESSIVE;
+				status_calc_mob(md,0); //Recalc their stats based on passive bonus
+				md->status.hp = md->status.max_hp; //Must be here or the code wont update it
+				// @showsummon command implementation [Brainstorm]
+				if(sd->state.showsummon){
+					char output[256];
+					sprintf(output,
+						"[Summon] HP : %d | STR : %d DEX : %d VIT : %d INT : %d AGI : %d LUK : %d",
+						md->status.max_hp,md->status.str,md->status.dex,md->status.vit,md->status.int_,md->status.agi,md->status.luk);
+					clif_disp_onlyself(sd,output,strlen(output));
+					sprintf(output,
+						"[%s] ATK : %d~%d | DEF: %d+%d MDEF: %d+%d | HIT: %d FLEE: %d",
+						md->name,md->status.rhw.atk,md->status.rhw.atk2,md->status.def,md->status.def2,md->status.mdef,md->status.mdef2,md->status.hit,md->status.flee);
+					clif_disp_onlyself(sd,output,strlen(output));
+				}
+				md->deletetimer = add_timer(gettick() + skill_get_time(skillid,skilllv), mob_timer_delete, id, 0);
+			}
+		}
+		break;
 	case NC_SKELETON: // Raise Skeleton [Brain]
 	case NC_ARCHER: // Raise Archer Skeleton
@@ -6317,56 +6321,55 @@
 	case NC_SHADOW: // Raise Shadow
 	case NC_WRAITH: // Raise Wraith
-	if( sd )
-	{
-		static const int mob_skeleton[5]={ 3201, 3202, 3203, 3204, 3205 }; // Skeleton, Orc Skeleton, Soldier Skeleton, Pirate Skeleton, Skeleton General
-		static const int mob_archer[5]={ 3206, 3207, 3208, 3209, 3210 }; // Archer Skeleton, Firelock Soldier
-		static const int mob_zombie[5]={ 3211, 3212, 3213, 3214, 3215 }; // Zombie, Ghoul, Zombie Master
-		static const int mob_mummy[5]={ 3216, 3217, 3218, 3219, 3220 }; // Mummy, Ancient Mummy
-		static const int mob_ghost[5]={ 3221, 3222, 3223, 3224, 3225 }; // Whisper, Nightmare, Nightmare Terror
-		static const int mob_shadow[5]={ 3226, 3227, 3228, 3229, 3230 }; // Injustice, Raydric, Dullahan
-		static const int mob_wraith[5]={ 3231, 3232, 3233, 3234, 3235 }; // Wraith, Wraith Dead
-		int id;
-		int mob_class;
-		struct mob_data *md;
-
-		switch( skillid )
+		if( sd )
 		{
-		case NC_SKELETON: mob_class = mob_skeleton[skilllv-1]; break;
-		case NC_ARCHER:   mob_class = mob_archer[skilllv-1]; break;
-		case NC_ZOMBIE:   mob_class = mob_zombie[skilllv-1]; break;
-		case NC_MUMMY:	mob_class = mob_mummy[skilllv-1]; break;
-		case NC_GHOST:	mob_class = mob_ghost[skilllv-1]; break;
-		case NC_SHADOW:   mob_class = mob_shadow[skilllv-1]; break;
-		case NC_WRAITH:   mob_class = mob_wraith[skilllv-1]; break;
-		default:
-			mob_class = 1002; // poring
-			ShowDebug("skill_castend_pos2: undefined skill #%d used to raise mobs, defaulting to poring\n");
-			break;
-		}
-		id = mob_once_spawn(sd,src->m,src->x,src->y,"--ja--",mob_class,1,"");
-		if((md=(struct mob_data *)map_id2bl(id)))
-		{
-		md->master_id=sd->bl.id;
-		md->special_state.ai=1;
-		md->status.mode=md->db->status.mode|MD_AGGRESSIVE;
-		status_calc_mob(md,0); //Recalc their stats based on passive bonus
-		md->status.hp = md->status.max_hp; //Must be here or the code wont update it
-		// @showsummon command implementation [Brainstorm]
-		if(sd->state.showsummon){
-			char output[256];
-			sprintf(output,
-			"[Summon] HP : %d | STR : %d DEX : %d VIT : %d INT : %d AGI : %d LUK : %d",
-			md->status.max_hp,md->status.str,md->status.dex,md->status.vit,md->status.int_,md->status.agi,md->status.luk);
-			clif_disp_onlyself(sd,output,strlen(output));
-			sprintf(output,
-			"[%s] ATK : %d~%d | DEF: %d+%d MDEF: %d+%d | HIT: %d FLEE: %d",
-			md->name,md->status.rhw.atk,md->status.rhw.atk2,md->status.def,md->status.def2,md->status.mdef,md->status.mdef2,md->status.hit,md->status.flee);
-			clif_disp_onlyself(sd,output,strlen(output));
-		}
-		md->deletetimer = add_timer(gettick() + skill_get_time(skillid,skilllv), mob_timer_delete, id, 0);
-		}
-	}
-	break;
-
+			static const int mob_skeleton[5]={ 3201, 3202, 3203, 3204, 3205 }; // Skeleton, Orc Skeleton, Soldier Skeleton, Pirate Skeleton, Skeleton General
+			static const int mob_archer[5]={ 3206, 3207, 3208, 3209, 3210 }; // Archer Skeleton, Firelock Soldier
+			static const int mob_zombie[5]={ 3211, 3212, 3213, 3214, 3215 }; // Zombie, Ghoul, Zombie Master
+			static const int mob_mummy[5]={ 3216, 3217, 3218, 3219, 3220 }; // Mummy, Ancient Mummy
+			static const int mob_ghost[5]={ 3221, 3222, 3223, 3224, 3225 }; // Whisper, Nightmare, Nightmare Terror
+			static const int mob_shadow[5]={ 3226, 3227, 3228, 3229, 3230 }; // Injustice, Raydric, Dullahan
+			static const int mob_wraith[5]={ 3231, 3232, 3233, 3234, 3235 }; // Wraith, Wraith Dead
+			int id;
+			int mob_class;
+			struct mob_data *md;
+
+			switch( skillid )
+			{
+				case NC_SKELETON: mob_class = mob_skeleton[skilllv-1]; break;
+				case NC_ARCHER:   mob_class = mob_archer[skilllv-1]; break;
+				case NC_ZOMBIE:   mob_class = mob_zombie[skilllv-1]; break;
+				case NC_MUMMY:    mob_class = mob_mummy[skilllv-1]; break;
+				case NC_GHOST:    mob_class = mob_ghost[skilllv-1]; break;
+				case NC_SHADOW:   mob_class = mob_shadow[skilllv-1]; break;
+				case NC_WRAITH:   mob_class = mob_wraith[skilllv-1]; break;
+				default:
+					mob_class = 1002; // poring
+					ShowDebug("skill_castend_pos2: undefined skill #%d used to raise mobs, defaulting to poring\n");
+					break;
+			}
+			id = mob_once_spawn(sd,src->m,src->x,src->y,"--ja--",mob_class,1,"");
+			if((md=(struct mob_data *)map_id2bl(id)))
+			{
+				md->master_id=sd->bl.id;
+				md->special_state.ai=1;
+				md->status.mode=md->db->status.mode|MD_AGGRESSIVE;
+				status_calc_mob(md,0); //Recalc their stats based on passive bonus
+				md->status.hp = md->status.max_hp; //Must be here or the code wont update it
+//I bet this should NOT be here -- Critical
+				if(sd->state.showsummon){
+					char output[256];
+					sprintf(output,
+						"[Summon] HP : %d | STR : %d DEX : %d VIT : %d INT : %d AGI : %d LUK : %d",
+						md->status.max_hp,md->status.str,md->status.dex,md->status.vit,md->status.int_,md->status.agi,md->status.luk);
+					clif_disp_onlyself(sd,output,strlen(output));
+					sprintf(output,
+						"[%s] ATK : %d~%d | DEF: %d+%d MDEF: %d+%d | HIT: %d FLEE: %d",
+						md->name,md->status.rhw.atk,md->status.rhw.atk2,md->status.def,md->status.def2,md->status.mdef,md->status.mdef2,md->status.hit,md->status.flee);
+					clif_disp_onlyself(sd,output,strlen(output));
+				}
+				md->deletetimer = add_timer(gettick() + skill_get_time(skillid,skilllv), mob_timer_delete, id, 0);
+			}
+		}
+		break;
 
 
@@ -6395,5 +6398,5 @@
 			potion_hp = potion_hp * (100+i)/100;
 			potion_sp = potion_sp * (100+i)/100;
-
+			
 			if(potion_hp > 0 || potion_sp > 0) {
 				i = skill_get_splash(skillid, skilllv);
@@ -6417,5 +6420,5 @@
 			potion_hp = potion_hp * (100+i)/100;
 			potion_sp = potion_sp * (100+i)/100;
-
+			
 			if(potion_hp > 0 || potion_sp > 0) {
 				i = skill_get_splash(skillid, skilllv);
@@ -6439,5 +6442,5 @@
 		}
 		break;
-
+	
 	case HW_GRAVITATION:
 		if ((sg = skill_unitsetting(src,skillid,skilllv,x,y,0)))
@@ -6521,10 +6524,10 @@
 	if (sd && !(flag&1) && sd->state.arrow_atk) //Consume arrow if a ground skill was not invoked. [Skotlex]
 		battle_consume_ammo(sd, skillid, skilllv);
-
+		
 	return 0;
 }
 
 /*==========================================
- *
+ * 
  *------------------------------------------*/
 int skill_castend_map (struct map_session_data *sd, short skill_num, const char *map)
@@ -6534,5 +6537,5 @@
 //Simplify skill_failed code.
 #define skill_failed(sd) { sd->menuskill_id = sd->menuskill_val = 0; }
-	if(skill_num != sd->menuskill_id)
+	if(skill_num != sd->menuskill_id) 
 		return 0;
 
@@ -6569,5 +6572,5 @@
 		return 0;
 	}
-
+	
 	switch(skill_num)
 	{
@@ -6610,10 +6613,10 @@
 				}
 			}
-
+		
 			//When it's an item-used warp-portal, the skill-lv used is lost.. assume max level.
 			lv = sd->skillitem==skill_num?skill_get_max(skill_num):pc_checkskill(sd,skill_num);
 			wx = sd->menuskill_val>>16;
 			wy = sd->menuskill_val&0xffff;
-
+			
 			if( lv <= 0 ) return 0;
 			if( lv > 4 ) lv = 4; // crash prevention
@@ -6634,5 +6637,5 @@
 				return 0;
 			}
-
+			
 			// This makes Warp Portal fail if the cell is not empty
 			//if(skill_check_unit_range2(&sd->bl,wx,wy,skill_num,lv) > 0) {
@@ -6693,10 +6696,10 @@
 		return 0; //Nothing to remove, this unit is not overlapped.
 
-	if (unit->val1 != unit->group->skill_id)
+	if (unit->val1 != unit->group->skill_id) 
 	{	//Reset state
 		unit->val1 = unit->group->skill_id;
 		unit->val2 &= ~UF_ENSEMBLE;
 	}
-
+	
 	return map_foreachincell(skill_dance_overlap_sub, unit->bl.m,unit->bl.x,unit->bl.y,BL_SKILL, unit,flag);
 }
@@ -6782,7 +6785,8 @@
 	switch(skillid)
 	{
+//seems good.
 	case WL_HELLFIRE: // Warlock Hellfire [Brain]
-	if(map_flag_vs(src->m)) target = BCT_ALL;
-	break;
+		if(map_flag_vs(src->m)) target = BCT_ALL;
+		break;
 	case MG_SAFETYWALL:
 		val2=skilllv+1;
@@ -6860,5 +6864,5 @@
 			{	//Use the previous limit (minus the elapsed time) [Skotlex]
 				limit = old_sg->limit - DIFF_TICK(gettick(), old_sg->tick);
-				if (limit < 0)	//This can happen...
+				if (limit < 0)	//This can happen... 
 					limit = skill_get_time(skillid,skilllv);
 			}
@@ -7107,5 +7111,5 @@
 		return NULL;
 	}
-
+	
 
 	if (skillid == NJ_TATAMIGAESHI) //Store number of tiles.
@@ -7116,5 +7120,5 @@
 
 /*==========================================
- *
+ * 
  *------------------------------------------*/
 static int skill_unit_onplace (struct skill_unit *src, struct block_list *bl, unsigned int tick)
@@ -7129,5 +7133,5 @@
 	nullpo_retr(0, src);
 	nullpo_retr(0, bl);
-
+	
 	if(bl->prev==NULL || !src->alive || status_isdead(bl))
 		return 0;
@@ -7139,10 +7143,10 @@
 			&& !skill_get_inf2(sg->skill_id) == INF2_TRAP) //Traps work on top of land protector, magical or not [Brain]
 		return 0; //AoE skills are ineffective. [Skotlex]
-
+	
 	sc = status_get_sc(bl);
-
+	
 	if (sc && sc->option&OPTION_HIDE && sg->skill_id != WZ_HEAVENDRIVE)
 		return 0; //Hidden characters are immune to AoE skills except Heaven's Drive. [Skotlex]
-
+	
 	type = status_skill2sc(sg->skill_id);
 	sce = (sc && type != -1)?sc->data[type]:NULL;
@@ -7240,5 +7244,5 @@
 		}
 		break;
-
+	
 	case UNT_FOGWALL:
 		if (!sce)
@@ -7261,5 +7265,5 @@
 //			src->limit = DIFF_TICK(tick+700,sg->tick);
 //		break;
-
+	
 	case UNT_MOONLIT:
 		//Knockback out of area if affected char isn't in Moonlit effect
@@ -7275,5 +7279,5 @@
 
 /*==========================================
- *
+ * 
  *------------------------------------------*/
 int skill_unit_onplace_timer (struct skill_unit *src, struct block_list *bl, unsigned int tick)
@@ -7302,5 +7306,5 @@
 	tsc = status_get_sc(bl);
 	tstatus = status_get_status_data(bl);
-	if (sg->state.magic_power)  //For magic power.
+	if (sg->state.magic_power)  //For magic power. 
 	{
 		sc = status_get_sc(ss);
@@ -7331,5 +7335,5 @@
 			return 0;
 		ts->tick = tick+sg->interval;
-
+		
 		if ((skillid==CR_GRANDCROSS || skillid==NPC_GRANDDARKNESS) && !battle_config.gx_allhit)
 			ts->tick += sg->interval*(map_count_oncell(bl->m,bl->x,bl->y,BL_CHAR)-1);
@@ -7382,11 +7386,11 @@
 				if (status_isimmune(bl))
 					heal = 0;	/* é»éè²ã«ãŒãïŒããŒã«éïŒïŒ */
-		// Profane Soul reduces the healed recieved by 3% per skilllv [Brain]
-		if(tsd) {
-			heal = heal * (100 - pc_checkskill(tsd,AD_PROFANE)*3)/100;
-			//Wont heal even if he got elemental armors [Brain]
-			if(pc_checkskill(tsd,NC_PHYLACTERY)) heal = sg->skill_lv;
-		}
-
+//Okay?
+				// Profane Soul reduces the healed recieved by 3% per skilllv [Brain]
+				if(tsd) {
+					heal = heal * (100 - pc_checkskill(tsd,AD_PROFANE)*3)/100;
+					//Wont heal even if he got elemental armors [Brain]
+					if(pc_checkskill(tsd,NC_PHYLACTERY)) heal = sg->skill_lv;
+				}
 				clif_skill_nodamage(&src->bl, bl, AL_HEAL, heal, 1);
 				status_heal(bl, heal, 0, 0);
@@ -7399,5 +7403,6 @@
 
 		case UNT_EVILLAND:
-			if (tstatus->race!=RC_UNDEAD && tstatus->race!=RC_DEMON)
+			//Will heal demon and undead element monsters, but not players.
+			if (bl->type != BL_PC && !battle_check_undead(tstatus->race, tstatus->def_ele) && tstatus->race!=RC_DEMON)
 			{	//Damage enemies
 				if(battle_check_target(&src->bl,bl,BCT_ENEMY)>0)
@@ -7423,5 +7428,5 @@
 
 		case UNT_ATTACK_SKILLS:
-			switch (sg->skill_id)
+			switch (sg->skill_id) 
 			{
 				case SG_SUN_WARM: //SG skills [Komurka]
@@ -7461,5 +7466,5 @@
 				break;
 				default:
-					skill_attack(skill_get_type(sg->skill_id),ss,&src->bl,bl,sg->skill_id,sg->skill_lv,tick,0);
+					skill_attack(skill_get_type(sg->skill_id),ss,&src->bl,bl,sg->skill_id,sg->skill_lv,tick,0);			
 			}
 			break;
@@ -7485,5 +7490,5 @@
 				if (status_change_start(bl,type,10000,sg->skill_lv,sg->group_id,0,0,sec, 8))
 				{
-					struct TimerData* td = tsc->data[type]?get_timer(tsc->data[type]->timer):NULL;
+					struct TimerData* td = tsc->data[type]?get_timer(tsc->data[type]->timer):NULL; 
 					if (td) sec = DIFF_TICK(td->tick, tick);
 					map_moveblock(bl, src->bl.x, src->bl.y, tick);
@@ -7556,5 +7561,5 @@
 			clif_skill_nodamage(&src->bl, bl, AL_HEAL, heal, 1);
 			status_heal(bl, heal, 0, 0);
-			break;
+			break;	
 		}
 
@@ -7731,5 +7736,5 @@
 			status_change_end(bl,type,-1);
 		break;
-
+		
 	case UNT_SPIDERWEB:
 		{
@@ -7759,5 +7764,5 @@
 	if (sc && !sc->count)
 		sc = NULL;
-
+	
 	type = status_skill2sc(skill_id);
 	sce = (sc && type != -1)?sc->data[type]:NULL;
@@ -7776,5 +7781,5 @@
 		case BD_ETERNALCHAOS:
 		case BD_DRUMBATTLEFIELD:
-		case BD_RINGNIBELUNGEN:
+		case BD_RINGNIBELUNGEN:	
 		case BD_ROKISWEIL:
 		case BD_INTOABYSS:
@@ -7785,5 +7790,5 @@
 				//FIXME: This code is not perfect, it doesn't checks for the real ensemble's owner,
 				//it only checks if you are doing the same ensemble. So if there's two chars doing an ensemble
-				//which overlaps, by stepping outside of the other parther's ensemble will cause you to cancel
+				//which overlaps, by stepping outside of the other parther's ensemble will cause you to cancel 
 				//your own. Let's pray that scenario is pretty unlikely and noone will complain too much about it.
 				skill_stop_dancing(bl);
@@ -7800,5 +7805,5 @@
 				status_change_end(bl, type, -1);
 			break;
-
+			
 		case BA_POEMBRAGI:
 		case BA_WHISTLE:
@@ -7807,5 +7812,5 @@
 		case DC_HUMMING:
 		case DC_DONTFORGETME:
-		case DC_FORTUNEKISS:
+		case DC_FORTUNEKISS:	
 		case DC_SERVICEFORYOU:
 			if (sce)
@@ -7857,5 +7862,5 @@
 
 	nullpo_retr(0, group);
-
+  	
 	dissonance = skill_dance_switch(unit, 0);
 
@@ -7942,5 +7947,5 @@
 	if ((skillid != PR_BENEDICTIO && *c >=1) || *c >=2)
 		return 0; //Partner found for ensembles, or the two companions for Benedictio. [Skotlex]
-
+	
 	if (bl == src)
 		return 0;
@@ -7951,5 +7956,5 @@
 	if (tsd->sc.data[SC_SILENCE] || tsd->sc.opt1)
 		return 0;
-
+	
 	switch(skillid)
 	{
@@ -8036,5 +8041,5 @@
 
 /*==========================================
- *
+ * 
  *------------------------------------------*/
 static int skill_check_condition_mob_master_sub (struct block_list *bl, va_list ap)
@@ -8059,5 +8064,5 @@
 
 /*==========================================
- * Determines if a given skill should be made to consume ammo
+ * Determines if a given skill should be made to consume ammo 
  * when used by the player. [Skotlex]
  *------------------------------------------*/
@@ -8098,5 +8103,5 @@
 		sd->skillitem = sd->skillitemlv = 0;
 		//Need to do arrow state check.
-		sd->state.arrow_atk = skill_get_ammotype(skill)?1:0;
+		sd->state.arrow_atk = skill_get_ammotype(skill)?1:0; 
 		//Need to do Spiritball check.
 		sd->spiritball_old = sd->spiritball;
@@ -8108,5 +8113,5 @@
 	if (!sc->count)
 		sc = NULL;
-
+	
 	if(pc_is90overweight(sd)) {
 		clif_skill_fail(sd,skill,9,0);
@@ -8132,5 +8137,5 @@
 	if (sd->menuskill_id == AM_PHARMACY &&
 		(skill == AM_PHARMACY || skill == AC_MAKINGARROW || skill == BS_REPAIRWEAPON ||
-		skill == AM_TWILIGHT1 || skill == AM_TWILIGHT2  || skill == AM_TWILIGHT3
+		skill == AM_TWILIGHT1 || skill == AM_TWILIGHT2  || skill == AM_TWILIGHT3 
 	)) {
 		sd->skillitem = sd->skillitemlv = 0;
@@ -8356,5 +8361,5 @@
 		}
 		break;
-
+		
 	case TK_READYCOUNTER:
 	case TK_READYDOWN:
@@ -8384,8 +8389,8 @@
 				status_change_end(&sd->bl, SC_COMBO, -1);
 				sd->skillid_old = sd->skilllv_old = 0;
-				return 0; //Can't repeat previous combo skill.
+				return 0; //Can't repeat previous combo skill.				
 			}
 			break;
-		} else
+		} else 
 		if(sc->data[SC_COMBO]->val1 == skill)
 			break; //Combo ready.
@@ -8446,17 +8451,18 @@
 		}
 		break;
+//Weird to me.
 	case AD_FAMILIAR: //Adept Familiar [Flavio]
-	{
-		short familiar[1] ={ pc_readglobalreg(sd, "ADEPT_FAMILIAR") };
-		int maxcount = skill_get_maxcount(skill,lv);
-		int count = 0;
-		count = mob_countslave_class(&sd->bl, 1, familiar );
-		if( count >= maxcount )
 		{
-		clif_skill_fail(sd,skill,0,0);
-		return 0;
-		}
-	}
-	break;
+			short familiar[1] ={ pc_readglobalreg(sd, "ADEPT_FAMILIAR") };
+			int maxcount = skill_get_maxcount(skill,lv);
+			int count = 0;
+			count = mob_countslave_class(&sd->bl, 1, familiar );
+			if( count >= maxcount )
+			{
+				clif_skill_fail(sd,skill,0,0);
+				return 0;
+			}
+		}
+		break;
 	case NC_SKELETON: // Raise Skeleton [Brain]
 	case NC_ARCHER: // Raise Archer Skeleton
@@ -8466,32 +8472,31 @@
 	case NC_SHADOW: // Raise Shadow
 	case NC_WRAITH: // Raise Wraith
-	{// corrigido o limite de spawns [Flavio]
-		short summon1[5]={ 3201, 3202, 3203, 3204, 3205 }; // Skeleton, Orc Skeleton, Soldier Skeleton, Pirate Skeleton, Skeleton General
-		short summon2[5]={ 3206, 3207, 3208, 3209, 3210 }; // Archer Skeleton, Firelock Soldier
-		short summon3[5]={ 3211, 3212, 3213, 3214, 3215 }; // Zombie, Ghoul, Zombie Master
-		short summon4[5]={ 3216, 3217, 3218, 3219, 3220 }; // Mummy, Ancient Mummy
-		short summon5[5]={ 3221, 3222, 3223, 3224, 3225 }; // Whisper, Nightmare, Nightmare Terror
-		short summon6[5]={ 3226, 3227, 3228, 3229, 3230 }; // Injustice, Raydric, Dullahan
-		short summon7[5]={ 3231, 3232, 3233, 3234, 3235 }; // Wraith, Wraith Dead
-		int maxcount = skill_get_maxcount(skill,lv);
-		int count = 0;
-		switch( skill )
-		{
-		case NC_SKELETON: count = mob_countslave_class(&sd->bl, 5, summon1); break;
-		case NC_ARCHER: count = mob_countslave_class(&sd->bl, 5, summon2); break;
-		case NC_ZOMBIE: count = mob_countslave_class(&sd->bl, 5, summon3); break;
-		case NC_MUMMY: count = mob_countslave_class(&sd->bl, 5, summon4); break;
-		case NC_GHOST: count = mob_countslave_class(&sd->bl, 5, summon5); break;
-		case NC_SHADOW: count = mob_countslave_class(&sd->bl, 5, summon6); break;
-		case NC_WRAITH: count = mob_countslave_class(&sd->bl, 5, summon7); break;
-		}
-		if( count >= maxcount )
-		{
-		clif_skill_fail(sd,skill,0,0);
-		return 0;
-		}
-	}
-	break;
-
+		{// corrigido o limite de spawns [Flavio]
+			short summon1[5]={ 3201, 3202, 3203, 3204, 3205 }; // Skeleton, Orc Skeleton, Soldier Skeleton, Pirate Skeleton, Skeleton General
+			short summon2[5]={ 3206, 3207, 3208, 3209, 3210 }; // Archer Skeleton, Firelock Soldier
+			short summon3[5]={ 3211, 3212, 3213, 3214, 3215 }; // Zombie, Ghoul, Zombie Master
+			short summon4[5]={ 3216, 3217, 3218, 3219, 3220 }; // Mummy, Ancient Mummy
+			short summon5[5]={ 3221, 3222, 3223, 3224, 3225 }; // Whisper, Nightmare, Nightmare Terror
+			short summon6[5]={ 3226, 3227, 3228, 3229, 3230 }; // Injustice, Raydric, Dullahan
+			short summon7[5]={ 3231, 3232, 3233, 3234, 3235 }; // Wraith, Wraith Dead
+			int maxcount = skill_get_maxcount(skill,lv);
+			int count = 0;
+			switch( skill )
+			{
+			case NC_SKELETON: count = mob_countslave_class(&sd->bl, 5, summon1); break;
+			case NC_ARCHER: count = mob_countslave_class(&sd->bl, 5, summon2); break;
+			case NC_ZOMBIE: count = mob_countslave_class(&sd->bl, 5, summon3); break;
+			case NC_MUMMY: count = mob_countslave_class(&sd->bl, 5, summon4); break;
+			case NC_GHOST: count = mob_countslave_class(&sd->bl, 5, summon5); break;
+			case NC_SHADOW: count = mob_countslave_class(&sd->bl, 5, summon6); break;
+			case NC_WRAITH: count = mob_countslave_class(&sd->bl, 5, summon7); break;
+			}
+			if( count >= maxcount )
+			{
+				clif_skill_fail(sd,skill,0,0);
+				return 0;
+			}
+		}
+		break;
 	case WZ_FIREPILLAR: // celest
 		if (lv <= 5)	// no gems required at level 1-5
@@ -8502,5 +8507,5 @@
 		if(!(sc && sc->data[SC_SMA]))
 			return 0;
-		break;
+		break;	
 
 	case HT_POWER:
@@ -8554,5 +8559,5 @@
 					clif_skill_fail(sd,skill,0,0);
 					return 0;
-				}
+				}	
 			}
 		}
@@ -8606,5 +8611,5 @@
 		//Only invoke on skill begin cast (instant cast skill). [Kevin]
 		if(sp>0 && !type)
-		{
+		{ 
 			if (status->sp < (unsigned int)sp)
 				clif_skill_fail(sd,skill,1,0);
@@ -8632,5 +8637,5 @@
 		}
 		break;
-
+	
 	case NJ_ISSEN:
 		if (status->hp < 2) {
@@ -8644,5 +8649,5 @@
 	  	}
 		break;
-
+	
 	case NJ_ZENYNAGE:
 		if(sd->status.zeny < zeny) {
@@ -8686,5 +8691,5 @@
 			return 0;
 		}
-
+	
 		if(weapon && !pc_check_weapontype(sd,weapon)) {
 			clif_skill_fail(sd,skill,6,0);
@@ -8782,5 +8787,5 @@
 		if (sc && sc->data[SC_COMBO] && sc->data[SC_COMBO]->val1 == skill)
 			sd->ud.canmove_tick = gettick(); //When using a combo, cancel the can't move delay to enable the skill. [Skotlex]
-
+			
 		if (!unit_can_move(&sd->bl)) {
 			clif_skill_fail(sd,skill,0,0);
@@ -8873,10 +8878,10 @@
 int skill_castfix (struct block_list *bl, int skill_id, int skill_lv)
 {
-	int time = skill_get_cast(skill_id, skill_lv);
+	int time = skill_get_cast(skill_id, skill_lv);	
 	struct map_session_data *sd;
 
 	nullpo_retr(0, bl);
 	sd = BL_CAST(BL_PC, bl);
-
+	
 	// calculate base cast time (reduced by dex)
 	if (!(skill_get_castnodex(skill_id, skill_lv)&1)) {
@@ -8926,12 +8931,12 @@
 			status_change_end(bl, SC_SUFFRAGIUM, -1);
 		}
-	if (sc->data[SC_DECREPIFY]) // Necro Decrepify [Brain]
-		if(sc->data[SC_DECREPIFY]->val2>=3)
-		time += time * 25/100; //+25% cast time
-	if (sc->data[SC_CURSETONGUES]) { //Warlock Curse of Tongues [Brain]
-		time += time * sc->data[SC_CURSETONGUES]->val2 / 100;
-		status_change_end(bl, SC_CURSETONGUES, -1);
-	}
-
+//Curse skills...
+		if (sc->data[SC_DECREPIFY]) // Necro Decrepify [Brain]
+			if(sc->data[SC_DECREPIFY]->val2>=3)
+				time += time * 25/100; //+25% cast time
+		if (sc->data[SC_CURSETONGUES]) { //Warlock Curse of Tongues [Brain]
+			time += time * sc->data[SC_CURSETONGUES]->val2 / 100;
+			status_change_end(bl, SC_CURSETONGUES, -1);
+		}
 		if (sc->data[SC_MEMORIZE]) {
 			time>>=1;
@@ -8952,5 +8957,5 @@
 	int delaynodex = skill_get_delaynodex(skill_id, skill_lv);
 	int time = skill_get_delay(skill_id, skill_lv);
-
+	
 	nullpo_retr(0, bl);
 
@@ -8959,5 +8964,5 @@
 
 	if (bl->type&battle_config.no_skill_delay)
-		return battle_config.min_skill_delay_limit;
+		return battle_config.min_skill_delay_limit; 
 
 	if (time < 0)
@@ -8976,5 +8981,5 @@
 	default:
 		if (battle_config.delay_dependon_dex && !(delaynodex&1))
-		{	// if skill delay is allowed to be reduced by dex
+		{	// if skill delay is allowed to be reduced by dex 
 			int scale = battle_config.castrate_dex_scale - status_get_dex(bl);
 			if (scale > 0)
@@ -8984,5 +8989,5 @@
 		}
 		if (battle_config.delay_dependon_agi && !(delaynodex&1))
-		{	// if skill delay is allowed to be reduced by agi
+		{	// if skill delay is allowed to be reduced by agi 
 			int scale = battle_config.castrate_dex_scale - status_get_agi(bl);
 			if (scale > 0)
@@ -9028,5 +9033,5 @@
 
 /*=========================================
- *
+ * 
  *-----------------------------------------*/
 void skill_brandishspear_first (struct square *tc, int dir, int x, int y)
